/*
 *	TOPPERS/ASP Kernel
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Advanced Standard Profile Kernel
 *	
 *	Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *									Toyohashi Univ. of Technology, JAPAN
 *	Copyright (C) 2007		by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2008-2009 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *
 *	@(#) $Id: start.S 555 2007-10-28 15:12:15Z honda $
 */

/*
 *	ͥбΥȥåץ⥸塼(SH12A)
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val) 	(val)		 /* uint_tޥ */
#define ULONG_C(val)	(val)		 /* ulong_tޥ */
#define CAST(type, val) (val)		 /* 㥹ȤԤޥ */
#include "kernel_impl.h"

	.text
	.global _start
	.align	2
_start:
	/*
	 *	SR롣
	 *	ߥåȤ롣
	 */
	mov.l  _iipm_disall_start, r0
	ldc    r0, sr

	/*
	 *	󥿥ƥѤΥåν
	 */
	mov.l  _kernel_istkpt_p, r1
	mov.l  @r1, r15

	/*
	 *	_hardware_init_hook ƤӽФ(0Ǥʤ)
	 *
	 *	åȥϡɥ˰¸ɬפʽϡ
	 *	hardware_init_hookȤؿѰդ롥
	 */
start_0:
	mov.l  _hardware_init_hook_start, r0
	tst    r0, r0
	bt	   start_1
#ifdef TOPPERS_SUPPORT_SH2A_INSTRUCTION
	jsr/n  @r0
#else /* TOPPERS_SUPPORT_SH2A_INSTRUCTION */
	jsr    @r0
	 nop
#endif /* TOPPERS_SUPPORT_SH2A_INSTRUCTION */
	
	/*
	 * bss򥯥ꥢ
	 *
	 *	ƥ4Хȶ֤ƤΤǡ
	 *	_end4ХȶǤʤȤƤ⡢
	 *	٤Υ񤭤뤳ȤϤʤ
	 *	ʲdataνƱ͡
	 */
start_1:
	mov.l  _bss_start_p, r1
	mov.l  _end_p, r2
	cmp/eq r1, r2
	bt	   start_3
	mov    #0, r0
#ifdef TOPPERS_SUPPORT_SH2E_INSTRUCTION
	/*
	 *	ٱ䥹åȡ(a)ԡˤϡ롼פæФݤˤ
	 *	¹ԤΤǡͽᡢ롼פβ1󸺤餷Ƥ
	 *	ա_endϤ3ʲȱ黻̤ˤʤꡢNG
	 */
	add    #-4, r2
start_2:
	cmp/hi r1, r2
	bt/s   start_2
	 mov.l  r0, @r1+	/*  (a) 쥸r0 */
#else /* TOPPERS_SUPPORT_SH2E_INSTRUCTION */
	/*
	 *	嵭(a)Ԥεեå̿᤬ʤƤ⡢_end¦
	 *	ԡˡ⤢뤬ޤǤϤƤʤ
	 *	_end4̤ڤ夲ɬפ롣
	 */
start_2:
	mov.l  r0, @r1
	add    #4, r1
	cmp/hi r1, r2
	bt	   start_2
#endif /* TOPPERS_SUPPORT_SH2E_INSTRUCTION */

	/*
	 *	dataROMбˡ
	 *
	 *	__idata_start  __idata_end ޤǤ__data_start ʹߤ
	 *	ԡ롥
	 */
start_3:
	mov.l  __idata_start_p, r1
	mov.l  __idata_end_p, r2
	cmp/eq r1, r2
	bt	   start_5
	mov.l  __data_start_p, r3
#ifdef TOPPERS_SUPPORT_SH2E_INSTRUCTION
	/*
	 *	ٱ䥹åȡ(b)ԡˤϡ롼פæФݤˤ
	 *	¹ԤΤǡͽᡢ롼פβ1󸺤餷Ƥ
	 *	ա__idata_endϤ3ʲȱ黻̤ˤʤꡢNG
	 */
	add    #-4, r2
start_4:
	mov.l  @r1+, r0
	cmp/hi r1, r2
	bt/s   start_4
	 mov.l  r0, @r3+	/*  (b)쥸r0  */
#else /* TOPPERS_SUPPORT_SH2E_INSTRUCTION */
start_4:
	mov.l  @r1+, r0
	cmp/hi r1, r2
	mov.l  r0, @r3
	add    #4, r3
	bt	   start_4
#endif /* TOPPERS_SUPPORT_SH2E_INSTRUCTION */

	/*
	 *	_software_init_hook ƤӽФ0 Ǥʤˡ
	 *
	 *	եȥĶä˥饤֥ˤ˰¸ɬפʽ
	 *	ϡsoftware_init_hook ȤؿѰդ
	 *	褤
	 */
start_5:
	mov.l  _software_init_hook_start, r0
	tst    r0, r0
	bt	   start_6
#ifdef TOPPERS_SUPPORT_SH2A_INSTRUCTION
	jsr/n  @r0
#else /* TOPPERS_SUPPORT_SH2A_INSTRUCTION */
	jsr    @r0
	 nop
#endif /* TOPPERS_SUPPORT_SH2A_INSTRUCTION */

start_6:
	/*
	 *	ͥư
	 */
	mov.l  _sta_ker_start, r0
#ifdef TOPPERS_SUPPORT_SH2A_INSTRUCTION
	jsr/n  @r0
#else /* TOPPERS_SUPPORT_SH2A_INSTRUCTION */
	jsr    @r0
	 nop
#endif /* TOPPERS_SUPPORT_SH2A_INSTRUCTION */

	.align 2
_iipm_disall_start:
	.long IIPM_DISALL
_kernel_istkpt_p:
	.long __kernel_istkpt
_bss_start_p:
	.long __bss_start
_end_p:
	.long _end
__idata_start_p:
	.long __idata_start
__idata_end_p:
	.long __idata_end
__data_start_p:
	.long __data_start

_hardware_init_hook_start:
	.long _hardware_init_hook
_software_init_hook_start:
	.long _software_init_hook
_sta_ker_start:
	.long _sta_ker

